# Stepwise

## Dimensions and Genres

Each time you start a run, a genre is chosen from a predefined list of **Dimensions**. Which dimension is chosen will dictate the rules for that run, altering the map's generation and overall goals for that save file. Some talking monsters may change their dialog, or some monsters may only spawn in some dimensions but not others.

Some recurring elements will exist in all dimensions to provide some stability, but will often be warped to fit - for example, if the "fantasy" dimension has Cid, the dwarven shopkeeper, the "scifi" dimension has C.I.D., the Customer Inventory Droid.

Here's a few potential options, which will absolutely change over time:

* Sword and Sorcery (LotR, D&D)
* GitS/Neuromancer/Digitized Minds
* Steampunk/Clockpunk/Crystalpunk (deeper areas have older tech)
* Post-Post-Apocalypse (Nausicaa)
* Shakespeare, A Tragedy
* Fairy Tales and Fables (Brothers Grimm)
* Secret Agent Espionage
* Mythic Odyssey
* Dreamlands/Cthulhu Horror
* Stargates/Sliders
* Isekai Protag Syndrome
* Gunslingers (Wild West)

## Notes, Concepts and Ideas

* Color-based effects or biomes that only have an impact when in the FOV?
* The "obscurity" is a random value set at the beginning of a run, and lost upon death. The game will have various secrets, some of which are only accessible via certain obscurity values.

## Links And Resources

https://rogueliketutorials.com/

https://python-tcod.readthedocs.io/en/latest/

## Setup and Notes

```bash
python3 -m venv venv
./venv/bin/tcod
```

heapq is a thing for the speed sorting