#!venv/bin/python
import tcod

from engine import Engine
from procgen import generate_floor_map
from message_log import Message
import colors

def main() -> None:
	#screen dimensions depend partially on the tileset
	tileset = tcod.tileset.load_tilesheet("assets/dejavu10x10_gs_tc.png", 32, 8, tcod.tileset.CHARMAP_TCOD)

	#how big is the map's dimensions
	map_width = 80
	map_height = 40

	ui_height = 5

	#tcod stuff
	context = tcod.context.new(
		columns = map_width,
		rows = map_height,
		tileset = tileset,
		title = "Stepwise Roguelike",
		vsync = True
	)

	console = context.new_console(map_width, map_height + ui_height, order="F")

	engine = Engine(
		#is created externally, because
		floor_map = generate_floor_map(map_width, map_height, room_width_max=12, room_height_max=12),
		intro_msg = Message("Welcome to the Cave of Gobbos!", colors.welcome_text),
		ui_height = ui_height,
	)

	#game loop that never returns
	engine.run_loop(context, console)

# this seems odd to me
if __name__ == "__main__":
	main()